diff --git a/base/server/src/scriptlets/configuration.py b/base/server/src/scriptlets/configuration.py
index c13e7eba2a63fecc7b42bc266f7f7e4233f48916..1058ea91237da52ebf8a04e0af2a20a5d2d4a379 100644
--- a/base/server/src/scriptlets/configuration.py
+++ b/base/server/src/scriptlets/configuration.py
@@ -21,8 +21,6 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 import json
@@ -34,8 +32,9 @@ import pki.encoder
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
-        if config.str2bool(master['pki_skip_configuration']):
+    def spawn(self, deployer):
+        
+        if config.str2bool(deployer.master_dict['pki_skip_configuration']):
             config.pki_log.info(log.SKIP_CONFIGURATION_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
@@ -44,97 +43,97 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
 
         # Place "slightly" less restrictive permissions on
         # the top-level client directory ONLY
-        util.directory.create(master['pki_client_subsystem_dir'],
+        deployer.directory.create(deployer.master_dict['pki_client_subsystem_dir'],
             uid=0, gid=0,
             perms=config.PKI_DEPLOYMENT_DEFAULT_CLIENT_DIR_PERMISSIONS)
         # Since 'certutil' does NOT strip the 'token=' portion of
         # the 'token=password' entries, create a client password file
         # which ONLY contains the 'password' for the purposes of
         # allowing 'certutil' to generate the security databases
-        util.password.create_password_conf(
-            master['pki_client_password_conf'],
-            master['pki_client_database_password'], pin_sans_token=True)
-        util.file.modify(master['pki_client_password_conf'],
+        deployer.password.create_password_conf(
+            deployer.master_dict['pki_client_password_conf'],
+            deployer.master_dict['pki_client_database_password'], pin_sans_token=True)
+        deployer.file.modify(deployer.master_dict['pki_client_password_conf'],
                          uid=0, gid=0)
         # Similarly, create a simple password file containing the
         # PKCS #12 password used when exporting the "Admin Certificate"
         # into a PKCS #12 file
-        util.password.create_client_pkcs12_password_conf(
-            master['pki_client_pkcs12_password_conf'])
-        util.file.modify(master['pki_client_pkcs12_password_conf'])
-        util.directory.create(master['pki_client_database_dir'],
+        deployer.password.create_client_pkcs12_password_conf(
+            deployer.master_dict['pki_client_pkcs12_password_conf'])
+        deployer.file.modify(deployer.master_dict['pki_client_pkcs12_password_conf'])
+        deployer.directory.create(deployer.master_dict['pki_client_database_dir'],
                               uid=0, gid=0)
-        util.certutil.create_security_databases(
-            master['pki_client_database_dir'],
-            master['pki_client_cert_database'],
-            master['pki_client_key_database'],
-            master['pki_client_secmod_database'],
-            password_file=master['pki_client_password_conf'])
-        util.symlink.create(master['pki_systemd_service'],
-                            master['pki_systemd_service_link'])
+        deployer.certutil.create_security_databases(
+            deployer.master_dict['pki_client_database_dir'],
+            deployer.master_dict['pki_client_cert_database'],
+            deployer.master_dict['pki_client_key_database'],
+            deployer.master_dict['pki_client_secmod_database'],
+            password_file=deployer.master_dict['pki_client_password_conf'])
+        deployer.symlink.create(deployer.master_dict['pki_systemd_service'],
+                            deployer.master_dict['pki_systemd_service_link'])
 
         # Start/Restart this Apache/Tomcat PKI Process
-        if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+        if deployer.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
             apache_instance_subsystems =\
-                util.instance.apache_instance_subsystems()
+                deployer.instance.apache_instance_subsystems()
             if apache_instance_subsystems == 1:
-                util.systemd.start()
+                deployer.systemd.start()
             elif apache_instance_subsystems > 1:
-                util.systemd.restart()
-        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                deployer.systemd.restart()
+        elif deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # Optionally prepare to enable a java debugger
             # (e. g. - 'eclipse'):
-            if config.str2bool(master['pki_enable_java_debugger']):
+            if config.str2bool(deployer.master_dict['pki_enable_java_debugger']):
                 config.prepare_for_an_external_java_debugger(
-                    master['pki_target_tomcat_conf_instance_id'])
+                    deployer.master_dict['pki_target_tomcat_conf_instance_id'])
             tomcat_instance_subsystems =\
-                len(util.instance.tomcat_instance_subsystems())
+                len(deployer.instance.tomcat_instance_subsystems())
             if tomcat_instance_subsystems == 1:
-                util.systemd.start()
+                deployer.systemd.start()
             elif tomcat_instance_subsystems > 1:
-                util.systemd.restart()
+                deployer.systemd.restart()
 
         # wait for startup
-        status = util.instance.wait_for_startup(60)
+        status = deployer.instance.wait_for_startup(60)
         if status == None:
             config.pki_log.error("server failed to restart",
                     extra=config.PKI_INDENTATION_LEVEL_2)
             raise Exception("server failed to restart")
 
         # Optionally wait for debugger to attach (e. g. - 'eclipse'):
-        if config.str2bool(master['pki_enable_java_debugger']):
+        if config.str2bool(deployer.master_dict['pki_enable_java_debugger']):
             config.wait_to_attach_an_external_java_debugger()
 
-        config_client = util.config_client()
         # Construct PKI Subsystem Configuration Data
         data = None
-        if master['pki_instance_type'] == "Apache":
-            if master['pki_subsystem'] == "RA":
+        if deployer.master_dict['pki_instance_type'] == "Apache":
+            if deployer.master_dict['pki_subsystem'] == "RA":
                 config.pki_log.info(log.PKI_CONFIG_NOT_YET_IMPLEMENTED_1,
-                    master['pki_subsystem'],
+                    deployer.master_dict['pki_subsystem'],
                     extra=config.PKI_INDENTATION_LEVEL_2)
                 return self.rv
-        elif master['pki_instance_type'] == "Tomcat":
+        elif deployer.master_dict['pki_instance_type'] == "Tomcat":
             # CA, KRA, OCSP, TKS, or TPS
-            data = config_client.construct_pki_configuration_data()
+            data = deployer.config_client.construct_pki_configuration_data()
         
         # Configure the substem
-        config_client.configure_pki_data(
+        deployer.config_client.configure_pki_data(
             json.dumps(data, cls=pki.encoder.CustomTypeEncoder))
 
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
+        
         config.pki_log.info(log.CONFIGURATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
-           util.instance.apache_instance_subsystems() == 1:
-            if util.directory.exists(master['pki_client_dir']):
-                util.directory.delete(master['pki_client_dir'])
-            util.symlink.delete(master['pki_systemd_service_link'])
-        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-             len(util.instance.tomcat_instance_subsystems()) == 1:
-            if util.directory.exists(master['pki_client_dir']):
-                util.directory.delete(master['pki_client_dir'])
-            util.symlink.delete(master['pki_systemd_service_link'])
+        if deployer.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+           deployer.instance.apache_instance_subsystems() == 1:
+            if deployer.directory.exists(deployer.master_dict['pki_client_dir']):
+                deployer.directory.delete(deployer.master_dict['pki_client_dir'])
+            deployer.symlink.delete(deployer.master_dict['pki_systemd_service_link'])
+        elif deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+             len(deployer.instance.tomcat_instance_subsystems()) == 1:
+            if deployer.directory.exists(deployer.master_dict['pki_client_dir']):
+                deployer.directory.delete(deployer.master_dict['pki_client_dir'])
+            deployer.symlink.delete(deployer.master_dict['pki_systemd_service_link'])
         return self.rv
diff --git a/base/server/src/scriptlets/finalization.py b/base/server/src/scriptlets/finalization.py
index 6387146c749e6093958e507200e406f3c2f75a28..17a6096f7e767501211c92cc0e33ef07dcc17c29 100644
--- a/base/server/src/scriptlets/finalization.py
+++ b/base/server/src/scriptlets/finalization.py
@@ -21,8 +21,6 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-import pkihelper as util
 import pkimanifest as manifest
 import pkimessages as log
 import pkiscriptlet
@@ -32,14 +30,15 @@ import pkiscriptlet
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
-        if master['pki_subsystem'] == "CA" and\
-           config.str2bool(master['pki_external_step_two']):
+    def spawn(self, deployer):
+        
+        if deployer.master_dict['pki_subsystem'] == "CA" and\
+           config.str2bool(deployer.master_dict['pki_external_step_two']):
             # must check for 'External CA Step 2' installation PRIOR to
             # 'pki_skip_installation' since this value has been set to true
             # by the initialization scriptlet
             pass
-        elif config.str2bool(master['pki_skip_installation']):
+        elif config.str2bool(deployer.master_dict['pki_skip_installation']):
             config.pki_log.info(log.SKIP_FINALIZATION_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
@@ -47,24 +46,24 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # For debugging/auditing purposes, save a timestamped copy of
         # this configuration file in the subsystem archive
-        util.file.copy(master['pki_user_deployment_cfg_replica'],
-                       master['pki_user_deployment_cfg_spawn_archive'])
+        deployer.file.copy(deployer.master_dict['pki_user_deployment_cfg_replica'],
+                       deployer.master_dict['pki_user_deployment_cfg_spawn_archive'])
         # Save a copy of the installation manifest file
-        config.pki_log.info(log.PKI_MANIFEST_MESSAGE_1, master['pki_manifest'],
+        config.pki_log.info(log.PKI_MANIFEST_MESSAGE_1, deployer.master_dict['pki_manifest'],
                             extra=config.PKI_INDENTATION_LEVEL_2)
         # for record in manifest.database:
         #     print tuple(record)
-        manifest.file.register(master['pki_manifest'])
+        manifest.file.register(deployer.master_dict['pki_manifest'])
         manifest.file.write()
-        util.file.modify(master['pki_manifest'], silent=True)
+        deployer.file.modify(deployer.master_dict['pki_manifest'], silent=True)
 
         # Also, for debugging/auditing purposes, save a timestamped copy of
         # this installation manifest file
-        util.file.copy(master['pki_manifest'],
-                       master['pki_manifest_spawn_archive'])
+        deployer.file.copy(deployer.master_dict['pki_manifest'],
+                       deployer.master_dict['pki_manifest_spawn_archive'])
         # Optionally, programmatically 'restart' the configured PKI instance
-        if config.str2bool(master['pki_restart_configured_instance']):
-            util.systemd.restart()
+        if config.str2bool(deployer.master_dict['pki_restart_configured_instance']):
+            deployer.systemd.restart()
         # Optionally, 'purge' the entire temporary client infrastructure
         # including the client NSS security databases and password files
         #
@@ -72,34 +71,35 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         #               placed under this infrastructure, it may accidentally
         #               be deleted!
         #
-        if config.str2bool(master['pki_client_database_purge']):
-            if util.directory.exists(master['pki_client_subsystem_dir']):
-                util.directory.delete(master['pki_client_subsystem_dir'])
+        if config.str2bool(deployer.master_dict['pki_client_database_purge']):
+            if deployer.directory.exists(deployer.master_dict['pki_client_subsystem_dir']):
+                deployer.directory.delete(deployer.master_dict['pki_client_subsystem_dir'])
         # If instance has not been configured, print the
         # configuration URL to the log
-        if config.str2bool(master['pki_skip_configuration']):
-            util.configuration_file.log_configuration_url()
+        if config.str2bool(deployer.master_dict['pki_skip_configuration']):
+            deployer.configuration_file.log_configuration_url()
         # Log final process messages
         config.pki_log.info(log.PKISPAWN_END_MESSAGE_2,
-                            master['pki_subsystem'],
-                            master['pki_instance_name'],
+                            deployer.master_dict['pki_subsystem'],
+                            deployer.master_dict['pki_instance_name'],
                             extra=config.PKI_INDENTATION_LEVEL_0)
-        util.file.modify(master['pki_spawn_log'], silent=True)
+        deployer.file.modify(deployer.master_dict['pki_spawn_log'], silent=True)
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
+        
         config.pki_log.info(log.FINALIZATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        util.file.modify(master['pki_destroy_log'], silent=True)
+        deployer.file.modify(deployer.master_dict['pki_destroy_log'], silent=True)
         # Start this Apache/Tomcat PKI Process
-        if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
-           util.instance.apache_instance_subsystems() >= 1:
-            util.systemd.start()
-        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-           len(util.instance.tomcat_instance_subsystems()) >= 1:
-            util.systemd.start()
+        if deployer.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+           deployer.instance.apache_instance_subsystems() >= 1:
+            deployer.systemd.start()
+        elif deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+           len(deployer.instance.tomcat_instance_subsystems()) >= 1:
+            deployer.systemd.start()
         config.pki_log.info(log.PKIDESTROY_END_MESSAGE_2,
-                            master['pki_subsystem'],
-                            master['pki_instance_name'],
+                            deployer.master_dict['pki_subsystem'],
+                            deployer.master_dict['pki_instance_name'],
                             extra=config.PKI_INDENTATION_LEVEL_0)
         return self.rv
diff --git a/base/server/src/scriptlets/infrastructure_layout.py b/base/server/src/scriptlets/infrastructure_layout.py
index f3535d7674d54f75634054966b5ae17453782b28..a80ab1d416777938414cec2c3ee4a30d23cf1b34 100644
--- a/base/server/src/scriptlets/infrastructure_layout.py
+++ b/base/server/src/scriptlets/infrastructure_layout.py
@@ -21,8 +21,6 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 
@@ -31,8 +29,9 @@ import pkiscriptlet
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
-        if config.str2bool(master['pki_skip_installation']):
+    def spawn(self, deployer):
+        
+        if config.str2bool(deployer.master_dict['pki_skip_installation']):
             config.pki_log.info(log.SKIP_ADMIN_DOMAIN_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
@@ -52,32 +51,32 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         # registry directories for storage of a copy of the original
         # deployment configuration file used to spawn this instance,
         # and save a copy of this file
-        util.directory.create(master['pki_registry_path'])
-        util.directory.create(master['pki_instance_type_registry_path'])
-        util.directory.create(master['pki_instance_registry_path'])
-        util.directory.create(master['pki_subsystem_registry_path'])
-        util.file.copy(master['pki_default_deployment_cfg'],
-                       master['pki_default_deployment_cfg_replica'])
+        deployer.directory.create(deployer.master_dict['pki_registry_path'])
+        deployer.directory.create(deployer.master_dict['pki_instance_type_registry_path'])
+        deployer.directory.create(deployer.master_dict['pki_instance_registry_path'])
+        deployer.directory.create(deployer.master_dict['pki_subsystem_registry_path'])
+        deployer.file.copy(deployer.master_dict['pki_default_deployment_cfg'],
+                       deployer.master_dict['pki_default_deployment_cfg_replica'])
 
-        print "Storing deployment configuration into " + config.pki_master_dict['pki_user_deployment_cfg_replica'] + "."
+        print "Storing deployment configuration into " + deployer.master_dict['pki_user_deployment_cfg_replica'] + "."
 
         #Archive the user deployment configuration excluding the sensitive parameters
-        sensitive_parameters = config.pki_master_dict['sensitive_parameters'].split()
+        sensitive_parameters = deployer.master_dict['sensitive_parameters'].split()
         sections = config.user_config.sections()
         for s in sections:
             for k in sensitive_parameters:
                 config.user_config.set(s, k, 'XXXXXXXX')
-        with open(master['pki_user_deployment_cfg_replica'], 'w') as f:
+        with open(deployer.master_dict['pki_user_deployment_cfg_replica'], 'w') as f:
             config.user_config.write(f)
 
         # establish top-level infrastructure, instance, and subsystem
         # base directories and create the "registry" symbolic link that
         # the "pkidestroy" executable relies upon
-        util.directory.create(master['pki_path'])
-        util.directory.create(master['pki_instance_path'])
-        util.directory.create(master['pki_subsystem_path'])
-        util.symlink.create(master['pki_instance_registry_path'],
-                            master['pki_subsystem_registry_link'])
+        deployer.directory.create(deployer.master_dict['pki_path'])
+        deployer.directory.create(deployer.master_dict['pki_instance_path'])
+        deployer.directory.create(deployer.master_dict['pki_subsystem_path'])
+        deployer.symlink.create(deployer.master_dict['pki_instance_registry_path'],
+                            deployer.master_dict['pki_subsystem_registry_link'])
         #
         # NOTE:  If "infrastructure_layout" scriptlet execution has been
         #        successfully executed to this point, the "pkidestroy" command
@@ -86,29 +85,30 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         # no need to establish top-level infrastructure logs
         # since it now stores 'pkispawn'/'pkidestroy' logs
         # and will already exist
-        # util.directory.create(master['pki_log_path'])
+        # deployer.directory.create(deployer.master_dict['pki_log_path'])
         # establish top-level infrastructure configuration
-        if master['pki_configuration_path'] !=\
+        if deployer.master_dict['pki_configuration_path'] !=\
            config.PKI_DEPLOYMENT_CONFIGURATION_ROOT:
-            util.directory.create(master['pki_configuration_path'])
+            deployer.directory.create(deployer.master_dict['pki_configuration_path'])
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
+        
         config.pki_log.info(log.ADMIN_DOMAIN_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # remove top-level infrastructure base
-        if master['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
-           util.instance.pki_instance_subsystems() == 0:
+        if deployer.master_dict['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
+           deployer.instance.pki_instance_subsystems() == 0:
             # remove top-level infrastructure base
-            util.directory.delete(master['pki_path'])
+            deployer.directory.delete(deployer.master_dict['pki_path'])
             # do NOT remove top-level infrastructure logs
             # since it now stores 'pkispawn'/'pkidestroy' logs
-            # util.directory.delete(master['pki_log_path'])
+            # deployer.directory.delete(deployer.master_dict['pki_log_path'])
             # remove top-level infrastructure configuration
-            if util.directory.is_empty(master['pki_configuration_path'])\
-               and master['pki_configuration_path'] !=\
+            if deployer.directory.is_empty(deployer.master_dict['pki_configuration_path'])\
+               and deployer.master_dict['pki_configuration_path'] !=\
                config.PKI_DEPLOYMENT_CONFIGURATION_ROOT:
-                util.directory.delete(master['pki_configuration_path'])
+                deployer.directory.delete(deployer.master_dict['pki_configuration_path'])
             # remove top-level infrastructure registry
-            util.directory.delete(master['pki_registry_path'])
+            deployer.directory.delete(deployer.master_dict['pki_registry_path'])
         return self.rv
diff --git a/base/server/src/scriptlets/initialization.py b/base/server/src/scriptlets/initialization.py
index f3839fb059a6b8346705bbb3ec8dd3c594282e8e..5075908d4c40a36f1e0619c83dcb94d76d18fb11 100644
--- a/base/server/src/scriptlets/initialization.py
+++ b/base/server/src/scriptlets/initialization.py
@@ -21,8 +21,6 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 
@@ -31,73 +29,75 @@ import pkiscriptlet
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
+    def spawn(self, deployer):
+        
         # begin official logging
         config.pki_log.info(log.PKISPAWN_BEGIN_MESSAGE_2,
-                            master['pki_subsystem'],
-                            master['pki_instance_name'],
+                            deployer.master_dict['pki_subsystem'],
+                            deployer.master_dict['pki_instance_name'],
                             extra=config.PKI_INDENTATION_LEVEL_0)
-        if config.str2bool(master['pki_skip_installation']):
+        if config.str2bool(deployer.master_dict['pki_skip_installation']):
             config.pki_log.info(log.SKIP_INITIALIZATION_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
         else:
             config.pki_log.info(log.INITIALIZATION_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
-            if master['pki_subsystem'] == "CA" and\
-               config.str2bool(master['pki_external_step_two']):
+            if deployer.master_dict['pki_subsystem'] == "CA" and\
+               config.str2bool(deployer.master_dict['pki_external_step_two']):
                 # verify that this type of "subsystem" currently EXISTS
                 # for this "instance" (External CA Step 2)
-                util.instance.verify_subsystem_exists()
-                master['pki_skip_installation'] = "True";
+                deployer.instance.verify_subsystem_exists()
+                deployer.master_dict['pki_skip_installation'] = "True";
             else:
                 # verify that this type of "subsystem" does NOT yet
                 # exist for this "instance"
-                util.instance.verify_subsystem_does_not_exist()
+                deployer.instance.verify_subsystem_does_not_exist()
                 # detect and avoid any namespace collisions
-                util.namespace.collision_detection()
+                deployer.namespace.collision_detection()
         # initialize 'uid' and 'gid'
-        util.identity.add_uid_and_gid(master['pki_user'], master['pki_group'])
+        deployer.identity.add_uid_and_gid(deployer.master_dict['pki_user'], deployer.master_dict['pki_group'])
         # establish 'uid' and 'gid'
-        util.identity.set_uid(master['pki_user'])
-        util.identity.set_gid(master['pki_group'])
+        deployer.identity.set_uid(deployer.master_dict['pki_user'])
+        deployer.identity.set_gid(deployer.master_dict['pki_group'])
         # verify existence of SENSITIVE configuration file data
-        util.configuration_file.verify_sensitive_data()
+        deployer.configuration_file.verify_sensitive_data()
         # verify existence of MUTUALLY EXCLUSIVE configuration file data
-        util.configuration_file.verify_mutually_exclusive_data()
+        deployer.configuration_file.verify_mutually_exclusive_data()
         # verify existence of PREDEFINED configuration file data
-        util.configuration_file.verify_predefined_configuration_file_data()
+        deployer.configuration_file.verify_predefined_configuration_file_data()
         # verify selinux context of selected ports
-        util.configuration_file.populate_non_default_ports()
-        util.configuration_file.verify_selinux_ports()
+        deployer.configuration_file.populate_non_default_ports()
+        deployer.configuration_file.verify_selinux_ports()
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
+        
         # begin official logging
         config.pki_log.info(log.PKIDESTROY_BEGIN_MESSAGE_2,
-                            master['pki_subsystem'],
-                            master['pki_instance_name'],
+                            deployer.master_dict['pki_subsystem'],
+                            deployer.master_dict['pki_instance_name'],
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # verify that this type of "subsystem" currently EXISTS
         # for this "instance"
-        util.instance.verify_subsystem_exists()
+        deployer.instance.verify_subsystem_exists()
         # verify that the command-line parameters match the values
         # that are present in the corresponding configuration file
-        util.configuration_file.verify_command_matches_configuration_file()
+        deployer.configuration_file.verify_command_matches_configuration_file()
         # establish 'uid' and 'gid'
-        util.identity.set_uid(master['pki_user'])
-        util.identity.set_gid(master['pki_group'])
+        deployer.identity.set_uid(deployer.master_dict['pki_user'])
+        deployer.identity.set_gid(deployer.master_dict['pki_group'])
         # get ports to remove selinux context
-        util.configuration_file.populate_non_default_ports()
+        deployer.configuration_file.populate_non_default_ports()
 
         # get deinstallation token
-        token = util.security_domain.get_installation_token(
+        token = deployer.security_domain.get_installation_token(
             config.pki_secdomain_user, config.pki_secdomain_pass)
 
         # remove kra connector from CA if this is a KRA
-        util.kra_connector.deregister()
+        deployer.kra_connector.deregister()
 
         # de-register instance from its Security Domain
         #
@@ -107,7 +107,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         #            instance's security domain may be a part of a
         #            tightly-coupled shared instance.
         #
-        util.security_domain.deregister(token)
+        deployer.security_domain.deregister(token)
         # ALWAYS Stop this Apache/Tomcat PKI Process
-        util.systemd.stop()
+        deployer.systemd.stop()
         return self.rv
